package com.vendor.burn.model.devices.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Messages;
import com.vendor.burn.model.BurnContext;
import com.vendor.burn.model.FlashType;
import com.vendor.burn.model.define.IChecker;
import com.vendor.burn.model.define.IFastbootProgressMonitor;
import com.vendor.burn.model.devices.IFrameSetting;
import com.vendor.burn.model.devices.ITab;
import com.vendor.burn.model.devices.burners.AbstractBurner;
import com.vendor.burn.model.event.EventType;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.serial.workers.AbstractBurnerWorker;
import com.vendor.burn.serial.workers.BadCheckBurnerWorker;
import com.vendor.burn.ui.burners.tabs.BadCheckTab;
import java.util.ArrayList;
import java.util.List;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.jobs.IJobChangeListener;
import org.eclipse.core.runtime.jobs.Job;

public class BadCheckBurner extends AbstractBurner implements IChecker {
  public BadCheckBurner(BurnContext burnContext) {
    super(burnContext);
  }
  
  protected IFrameSetting getFrameSetting() {
    return getBurnContext().getDeviceSetting().getFrameSetting();
  }
  
  public void burn(IFastbootProgressMonitor monitor) {}
  
  public void check(IFastbootProgressMonitor fastbootMonitor) {
    if (fastbootMonitor == null || fastbootMonitor.getEvent() == null)
      return; 
    fastbootMonitor.getEvent().init(EventType.CHECK);
    BadCheckBurnerWorker worker = getBurnerWorker();
    worker.setProgressMonitor(fastbootMonitor);
    worker.setFlashType(FlashType.nand);
    if (fastbootMonitor != null)
      fastbootMonitor.begin(); 
    if (fastbootMonitor != null) {
      FastbootEvent event = fastbootMonitor.getEvent();
      Object object = new Object(this, "Check Bad Blocks", worker, event, fastbootMonitor);
      showProgressDialog((Job)object);
      object.addJobChangeListener((IJobChangeListener)new Object(this, fastbootMonitor));
      object.schedule();
    } 
  }
  
  public IStatus checkBeforeCheck() {
    IStatus validSerialPort = validSerialPort();
    if (!isOK(validSerialPort))
      return validSerialPort; 
    return null;
  }
  
  public List<String> getSteps() {
    List<String> steps = new ArrayList<>();
    steps.add(Messages.CheckerBurner_Step_1);
    steps.add(Messages.CheckerBurner_Step_2);
    steps.add(Messages.CheckerBurner_Step_3);
    steps.add(Messages.CheckerBurner_Step_4);
    steps.add(Messages.CheckerBurner_Step_5);
    return steps;
  }
  
  public ITab getTab() {
    return (ITab)new BadCheckTab();
  }
  
  protected BadCheckBurnerWorker getBurnerWorker() {
    return new BadCheckBurnerWorker(this);
  }
  
  public void eraseBad(IFastbootProgressMonitor fastbootMonitor) {
    if (fastbootMonitor == null || fastbootMonitor.getEvent() == null)
      return; 
    fastbootMonitor.getEvent().init(EventType.ERASE);
    BadCheckBurnerWorker worker = getBurnerWorker();
    worker.setProgressMonitor(fastbootMonitor);
    worker.setFlashType(FlashType.nand);
    if (fastbootMonitor != null)
      fastbootMonitor.begin(); 
    if (fastbootMonitor != null) {
      FastbootEvent event = fastbootMonitor.getEvent();
      Object object = new Object(this, "Check nand scrub", worker, event, fastbootMonitor);
      showProgressDialog((Job)object);
      object.addJobChangeListener((IJobChangeListener)new Object(this, fastbootMonitor));
      object.schedule();
    } 
  }
  
  public void burn(IFastbootProgressMonitor monitor, String directory) {}
}
